<?php

/* ----------------------------------------------------------------------------
 *               INAF - National Institute for Astrophysics
 *               IRA  - Radioastronomical Institute - Bologna
 *               OATS - Astronomical Observatory - Trieste
 * ----------------------------------------------------------------------------
 *
 * Copyright (C) 2016 Istituto Nazionale di Astrofisica
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License Version 3 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

namespace RAP;

class UserHandler {

    public static function saveUser(User $user) {

        $dao = DAO::get();

        if ($user->id === null) {
            $user->id = $dao->createUser();
        }

        foreach ($user->identities as $identity) {
            if ($identity->id === null) {
                $identity->id = $dao->insertIdentity($identity, $user->id);
            }
        }

        foreach ($user->additionalEmailAddresses as $email) {
            if (!in_array($email, $user->additionalEmailAddresses)) {
                
            }
        }
    }

    public static function findUserByIdentity($type, $identifier) {

        return DAO::get()->findUserByIdentity($type, $identifier);
    }

    public static function joinUsers($userId1, $userId2) {

        global $GROUPER;

        if (isset($GROUPER)) {
            $gc = new GrouperClient($GROUPER);

            $groupsToMove = $gc->getSubjectGroups('RAP:' . $userId2);
            $gc->addMemberships('RAP:' . $userId1, $groupsToMove);
            $gc->removeMemberships('RAP:' . $userId2, $groupsToMove);
        }

        DAO::get()->joinUsers($userId1, $userId2);
    }

}
