<?php

/**
 * REST backend for JavaScript code.
 */
//

function checkSession() {

    startSession();

    global $session;
    if ($session->user === null) {
        http_response_code(401);
        die("You must be registered to perform this action");
    }
}

Flight::route('GET /user', function() {

    checkSession();
    global $session;

    $searchText = Flight::request()->query['search'];
    $session->searchUser($searchText);

    $jsRes = [];
    foreach ($session->userSearchResults as $searchResult) {
        array_push($jsRes, $searchResult->userDisplayText);
    }

    echo json_encode($jsRes);
});

Flight::route('POST /join', function() {

    checkSession();
    global $session;

    $selectedUserIndex = Flight::request()->data['selectedUserIndex'];
    $selectedSearchResult = $session->userSearchResults[$selectedUserIndex];
    $targetUserId = $selectedSearchResult->getUser()->id;

    $token = RAP\Util::createNewToken();
    RAP\DAO::get()->createJoinRequest($token, $session->user->id, $targetUserId);
    RAP\MailSender::sendJoinEmail($selectedSearchResult->getUser(), $session->user);

    echo $selectedSearchResult->userDisplayText;
});
